<template id="category-beneficiaries-stats">
  <div class="box box-warning">
    <div class="box-header with-border">
      <h3 class="box-title">Category beneficiaries stats</h3>
      <div class="box-tools pull-right">
        <button
          v-show="!show_table"
          @click="showAndHideComponents(true,false,false)"
          type="button"
          class="btn show-table-btn"
        >
          <i class="fa fa-table"></i>
        </button>
        <button
          v-show="!show_pie_chart"
          @click="showAndHideComponents(false,true,false)"
          type="button"
          class="btn show-chart-btn"
        >
          <i class="fa fa-chart-pie"></i>
        </button>
        <button
          v-if="!show_bar_chart"
          @click="showAndHideComponents(false,false,true)"
          type="button"
          class="btn show-chart-btn"
        >
          <i class="fa fa-chart-bar"></i>
        </button>
      </div>
    </div>
      <div class="box-body">
      <div class="chart">
          <div class="card">
            <div class="card-body">
            <div class="selector-area">
              <select
                class="form-control"
                id="category_name"
                @change="onChangeCategory()"
                v-model="selected_category"
              >
                <option value disabled>Select category</option>
                <option
                  v-for="(category,key) in categories"
                  v-bind:value="category"
                  v-bind:key="category"
                >{{ key }}</option>
              </select>
            </div>
            <hr>
            <div class="chart">
              <DoughnutChart v-if="show_pie_chart " :chartData="chartData" :options="optionsPie"></DoughnutChart>
              <BarChart v-if="show_bar_chart " :chartData="chartData" :options="optionsBar"></BarChart>
            </div>
            <div v-if="show_table && tableStats">
              <table class="table table-hover table-striped">
                <tbody>
                  <tr>
                    <th>Beneficiary name</th>
                    <th>Amount, €</th>
                    <th>Percentage</th>
                  </tr>

                  <tr v-for="result in tableStats.data" :key="result.name">
                    <td>{{ result.beneficiary_name}}</td>
                    <td>{{ result.amount }} €</td>
                    <td>{{ result.percentage }}%</td>
                  </tr>
                </tbody>
              </table>

              </div>
              <div v-if="show_table" class="card-footer">
                <pagination
                  class="paginator"
                  :data="tableStats"
                  @pagination-change-page="getTableStats"
                ></pagination>
              </div>
            </div>
            </div>
      </div>
    </div>
    <!-- /.box-body -->
  </div>
</template>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.13.0/moment.min.js"></script>
<script src="https://chartjs-plugin-datalabels.netlify.com/guide/positioning.html#clamping"></script>

<script>
import DoughnutChart from "./DoughnutChart.vue";
import BarChart from "./BarChart.vue";
import moment from "moment";

export default {
  props: ["date_interval", "interval", "stats", "categories"],

  components: {
    DoughnutChart,
    BarChart
  },

  data: function() {
    return {
      optionsPie: null,
      optionsBar: null,
      chartData: null,
      selected_category: "",
      show_table: false,
      tableStats: {},
      percentages: null,
      show_table: false,
      show_bar_chart: false,
      show_pie_chart: true
    };
  },

  created: function() {
    this.selected_category = Object.values(this.categories)[0]
    this.setChartValues(this.stats);
  },

  watch: {
    date_interval: function() {
      this.show_table = false;
      this.setChartValues(this.stats);
    },

    stats: function() {
      this.setChartValues(this.stats);
      this.selected_category = Object.values(this.categories)[0]
    }
  },

  methods: {
    showAndHideComponents(table, pie, bar) {
      if (table) {
        this.show_table = true;
        this.getTableStats();
      } else if (pie) {
        this.setChartValues(this.stats);
        this.show_table = false;
        this.show_bar_chart = false;
        this.show_pie_chart = true;
      }

      if (bar) {
        this.show_table = false;
        this.show_bar_chart = true;
        this.show_pie_chart = false;
      }
    },

    showTable() {
      this.show_table = true;
    },

    statsUrl(pagin) {
      let uri =
        "api/category-beneficiaries-stats/" +
        this.selected_category +
        "/" +
        this.interval +
        "?paginate=" +
        pagin;

      return uri;
    },

    onChangeCategory() {
      this.show_table = false;
      this.getChartValues();
    },

    getTableStats(page = 1) {
      axios
        .get(this.statsUrl(1), {
          params: {
            page: page
          }
        })
        .then(response => {
          this.tableStats = response.data.results;
        });
    },

    getChartValues() {
      axios.get(this.statsUrl(0)).then(response => {
        this.setChartValues(response.data);
      });
    },

    setChartValues: function(stats) {
  
      let labels = stats.results.map(list => {
        return list.beneficiary_name;
      });

      let amounts = stats.results.map(list => {
        return list.amount;
      });

      let percentages = stats.results.map(list => {
        return list.percentage;
      });

      this.assignChartValues(labels, amounts, percentages);
    },

    assignChartValues: function(labels, amounts, percentages) {
      this.chartData = {
        labels: labels,
        datasets: [
          {
            label: "Transaction sum",
            backgroundColor: Fire.getRandomColorHex(labels.length),
            borderColor: Fire.getRandomColorHex(),
            fill: true,
            data: amounts,
            datalabels: {
              labels: {
                title: {
                  font: {
                    weight: "bold",
                    size: 15
                  }
                }
              }
            }
          }
        ]
      };

      this.optionsPie = {
        title: {
          display: false
        },

        tooltips: {
          callbacks: {
            label: function(tooltipItem, data) {
              return data["datasets"][0]["data"][tooltipItem["index"]] + " €";
            },

            title: function(tooltipItem, data) {
              return data["labels"][tooltipItem[0]["index"]];
            }
          },
          xPadding: 8,
          backgroundColor: "#FFF",
          titleFontSize: 18,
          titleFontColor: "#0066ff",
          bodyFontColor: "#000",
          bodyFontSize: 18,
          displayColors: false
        },

        plugins: {
          datalabels: {
            // formatter: function(value, context) {

            //   if(percentages[context.dataIndex] > 20) {
            //   return percentages[context.dataIndex] + "%";
            //   }

            //   else {
            //     return "";
            //   }
            // },
            color: "white",
            display: false
          }
        },

        callbacks: {
          labelColor: function(tooltipItem, chart) {
            return {
              borderColor: "red",
              backgroundColor: "red"
            };
          },
          labelTextColor: function(tooltipItem, chart) {
            return "red";
          }
        }
      };

      this.optionsBar = Object.assign({}, this.optionsPie);

      this.optionsBar.scales = {
          yAxes: [
            {
              scaleLabel: {
                display: true,
                labelString: "Amount, €"
              },
              ticks: {
               beginAtZero: true
              } 
            }
          ],
          xAxes: [
            {
              scaleLabel: {
                display: true,
                labelString: "categories"
              }
            }
          ]
        },

      this.optionsBar.legend = {
        display: false
      };
    }
  }
};
</script>
